/* tempverlauf.cc			letzte Aenderung: 14.1.2010 */
#define VERSION "Version 0.0"
/*
Uebersetzen auf Unix (Linux):
> make  ;siehe makefile

 Kurzbeschreibung: im EEPROM gespeicherte Temperaturen in eine xy-Dateien umwandeln

History:
18.5.2012	Erstellung (RP)
*/

#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string.h>

/************************* Vordeklarationen ***************************/
void unterprog(FILE *fp1,FILE *fp2);

/************************* Globale Variablen **************************/
int abstand=1;

/**************** Routinen zur Parameterauswertung ********************/
#define MAXARG 2
static char argflag[128];
void setargflags(char *s)
{
 int c;
 while(c= *s++)
  {if(c>='a' && c<='z')  c -= 'a'-'A';
   argflag[c&127]=1;
   if(c=='N') sscanf(s,"%d",&abstand);
  }
}

/*************************** Kleinkram ********************************/
bool istja(char *s)
{
 int c= *s;
 return (c=='j' || c=='J' || c=='y' || c=='Y');
}

/************** Klassen und Hauptteil des Programms *******************/

/************************* Hauptprogramm ******************************/
main(int argc,char *argv[])
{
 char quellname[80],zielname[80];
 FILE *fp1,*fp2;
 int i,j,c;
 quellname[0]=zielname[0]=0;
 if(argc<=0)
  {/* es wurde von WorkBench (GUI, Desktop, ...) gestartet */
  }
 else
  {/* es wurde von Shell (Terminal, Konsole, ...) gestartet */
   for(j=0,i=1;i<argc;i++)
	{if((c= *argv[i])=='-' || c=='?') setargflags(argv[i]);
	 else	{if(++j==1) strcpy(quellname,argv[i]);
		 else if(j==2) strcpy(zielname,argv[i]);
	}	}
  }
 if(argflag['?'] || j>MAXARG)
	{printf("tempverlauf  %s\n",VERSION);
	 printf("Anwendung: tempverlauf -flags Quelle.raw [Ziel.xy]\n");
	 printf("  flags: a = erster Wert von Wertepaaren verwenden\n");
	 printf("         b = zweiter Wert von Wertepaaren verwenden\n");
	 printf("         c = erste 2 Byte als Anzahl Punktepaare auswerten\n");
	 printf("         d = erste 2 Byte als Anzahl Punkte auswerten\n");
	 printf("         n = Anzahl Minuten zwischen zwei Messwerten (z.B. n5 fuer 5 Minuten)\n");
	 exit(0);
	}
 if(*quellname==0) {printf("Quellname:"); scanf("%s",quellname);}
 if(*zielname==0)  {printf("Zielname:"); scanf("%s",zielname);}
 if((fp1=fopen(quellname,"r"))==NULL)
  {printf("Datei '%s' nicht vorhanden\n",quellname); exit(0);}
 if((fp2=fopen(zielname,"r"))!=NULL)
  {printf("Datei '%s' schon vorhanden - nichts gespeichert.\n",zielname);
   fclose(fp2); fclose(fp1);
   exit(0);
  }
 if((fp2=fopen(zielname,"w"))==NULL)
  {
   printf("konnte Datei '%s' nicht erstellen\n",zielname);
   fclose(fp1);
   exit(0);
  }
 unterprog(fp1,fp2);
 fclose(fp1); fclose(fp2);
 return 0;
}/* ende von main */

void unterprog(FILE *fp1,FILE *fp2)
{
 int c1,c2,i,npkt,temp,t,dt=1;
 double temperatur;
 if(argflag['C'] || argflag['D'])
  {
   c1=getc(fp1);
   c2=getc(fp1);
   npkt=((c1&0xFF)<<8)+(c2&0xFF);
   if(argflag['D']) npkt/=2;
   printf("npkt=%d\n",npkt);//test
  }
 else npkt=32000;
 if(argflag['N'])
  {
   dt=abstand;
  }
 printf("dt=%d\n",dt);//test
 for(t=0,i=0;i<npkt && (c1=getc(fp1))!=EOF;i++,t+=dt)
  {
   c2=getc(fp1);
   if(argflag['B']) temp=c2; else temp=c1;
   temperatur = temp/4.0-40.0;
   fprintf(fp2,"%d  %f\n",t,temperatur);
  }
 if(i!=npkt)
  printf("Es konnten nur %d Punkte eingelesen werden (nicht %d).\n",i,npkt);
}
